function result = func_MyInterp2(x, factor, mode)

%x input data

%factor size of zoom

%mode the mode of interpolation

[nRowLR, nColumnLR] = size(x);

%symmetrical padding

% x_temp = x;

% x = zeros(nRowLR+1, nColumnLR+1);

% x(1:end-1,1:end-1) = x_temp;

% x(1:end, end) = x(1:end, end-1);

% x(end, 1:end) = x(end-1, 1:end);

 

nRowHR = nRowLR * factor;

nColumnHR = nColumnLR * factor;

[X_LR, Y_LR] = meshgrid(1:factor:nColumnHR, 1:factor:nRowHR);

[X_HR, Y_HR] = meshgrid(1:nColumnHR, 1:nRowHR);

result = interp2(X_LR, Y_LR, x, X_HR, Y_HR, mode);

result(1:nRowHR, nColumnHR) = result(1:nRowHR, nColumnHR-1);
result(nRowHR, 1:nColumnHR) = result(nRowHR-1, 1:nColumnHR);
